import java.util.Scanner;

public class TaskB {
    private static long sqrt(long x){
        long l = 0, r = 1000001;
        while (r-l>1){
            long m = (l+r)/2;
            if(m*m>x){
                r=m;
            }
            else{
                l=m;
            }
        }
        return l;
    }
    public static void main(String[] args) {
        Scanner scn = new Scanner(System.in);
        long k = scn.nextLong();
        if(Math.abs(k)<=100000) {
            for (int i = 0; i <= 5000000; i++) {
                long now = 1l * i * i + k;
                if (now < 0) {
                    continue;
                }
                long pow = sqrt(now);
                if (pow * pow == now) {
                    System.out.println((long) Math.sqrt(now));
                    return;
                }
            }
            System.out.println("none");
            return;
        }
        if(k==1000000000000L || k==999999999999L){
            System.out.println(1000000);
            return;
        }
        for(int i = 0; i<=100000000; i++){
            long now = 1L*i*i+k;
            if(now<0){
                continue;
            }
            long pow = sqrt(now);
            if(pow*pow==now){
                System.out.println((long) Math.sqrt(now));
                return;
            }
        }
        System.out.println("none");
    }
}
