import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.HashSet;
import java.util.Locale;
import java.util.Set;
import java.util.StringTokenizer;

public class TaskC {
    public void solve() throws IOException {
        int n = nextInt();
        int m = nextInt();
        int[] a = new int[n];
        int[] b = new int[m];
        int[] necPos = new int[n];
        boolean isStraight = true, isReverse = true;
        Set<Integer> necNumbers = new HashSet<>();
        for (int i = 0; i < m; i++) {
            b[i] = nextInt() - 1;
            if (!necNumbers.contains(b[i])) {
                necPos[b[i]] = Math.min(i, n - 1);
            }
            necNumbers.add(b[i]);
        }
        for (int i = 0; i < n; i++) {
            a[i] = nextInt() - 1;
        }
        if (n != m) {
            isReverse = false;
            isStraight = false;
        } else {
            for (int i = 0; i < n; i++) {
                if (a[i] != b[i]) {
                    isStraight = false;
                }
                if (a[i] != b[n - 1 - i]) {
                    isReverse = false;
                }
            }
        }
        int kol = 0;
        if (isStraight) {
            kol = n;
            System.out.println(n);
            StringBuffer s = new StringBuffer();
            for (int i = 0; i < n; i++) {
                s.append(n);
                s.append(' ');
            }
            System.out.println(s.toString());
            return;
        }
        if (isReverse) {
            kol = n - 1 + n;
            System.out.println(kol);
            StringBuffer s = new StringBuffer();
            for (int i = n; i > 1; i--) {
                s.append(i);
                s.append(' ');
            }
            for (int i = 0; i < n; i++) {
                s.append(n);
                s.append(' ');
            }
            System.out.println(s.toString());
            return;
        }

        StringBuffer s = new StringBuffer();
        for (int i = 0; i < n; i++) {
            if (!necNumbers.contains(i)) {
                necPos[i] = n - 1;
            }
        }
        for (int i = 0; i < m; i++) {
            if (b[i] == a[0]) {
                kol++;
                int now = a[0];
                necPos[now] = n - 1;
                for (int j = i + 1; j < m; j++) {
                    if (b[j] == now) {
                        necPos[now] = Math.min(n - 1, j - i - 1);
                        break;
                    }
                }
                s.append(necPos[now] + 1);
                s.append(' ');
                for (int k = 0; k < n; k++) {
                    if (k != now && necNumbers.contains(k)) {
                        necPos[k]--;
                    }
                }
                for (int k = 0; k < necPos[now]; k++) {
                    a[k] = a[k + 1];
                }
                a[necPos[now]] = now;
                continue;
            }
            while (a[0] != b[i]) {
                kol++;
                int now = a[0];
                s.append(necPos[now] + 1);
                s.append(' ');
                for (int k = 0; k < necPos[now]; k++) {
                    a[k] = a[k + 1];
                }
                a[necPos[now]] = now;
            }
            i--;
        }
        out.println(kol);
        out.println(s.toString());
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new TaskC().run();
    }
}
