import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.*;

public class TaskC {
    private static Set<Integer>[] g;
    private static boolean[] d;
    private static int n;
    private static int max = Integer.MIN_VALUE;
    private static int[] now, a;
    private static void generate(int i){
        if(i==n){
            now = new int[n];
            for(int j = 0; j<n; j++){
                now[j]=a[j];
            }
            for(int j = 0; j<n; j++){
                if(!d[j] && now[j]>=0){
                    now[j]=-3;
                    for(Integer x : g[j]){
                        if(now[x]>=0) {
                            if(g[x].contains(j)){
                                now[x]--;
                            }
                            now[x]--;
                        }
                    }
                }
            }
            check();
        }
        else{
            d[i]=false;
            generate(i+1);
            d[i]=true;
            generate(i+1);
        }
    }
    private static void check(){
        int kol = 0;
        for(int i = 0; i<n; i++){
            if(now[i]==0){
                kol++;
            }
        }
        max=Math.max(max, kol);
    }
    public void solve() throws IOException {
        n = nextInt();
        d = new boolean[n];
        a = new int[n];
        g = new Set[n];
        for (int i = 0; i < n; i++) {
            g[i] = new HashSet<>();
        }
        boolean isBambook = true;
        for (int i = 0; i < n; i++) {
            int x = nextInt() - 1;
            if(i==0 && x!=-2){
                isBambook=false;
            }
            if(i>0 && x!=i-1){
                isBambook=false;
            }
            if (x != -2) {
                a[i]++;
                g[i].add(x);
                g[x].add(i);
                a[x]++;
            }
        }
        if(n<=20){
            generate(0);
            System.out.println(max);
            return;
        }
        ArrayList<Integer> now;
        now = new ArrayList<>();
        for(int i = 0; i<n; i++){
            now.add(a[i]);
        }
        if(!isBambook) {
            while (true) {
                int max = Integer.MIN_VALUE, maxInd = -1;
                for (int i = 0; i < n; i++) {
                    if (now.get(i) > max) {
                        max = now.get(i);
                        maxInd = i;
                    }
                }
                if (max == 0) {
                    break;
                }
                now.set(maxInd, -3);
                for (Integer x : g[maxInd]) {
                    now.set(x, now.get(x) - 1);
                }
                g[maxInd].clear();
            }
            int kol = 0;
            for (int i = 0; i < n; i++) {
                if (now.get(i) == 0) {
                    kol++;
                }
            }
            System.out.println(kol);
            return;
        }
        else{
            System.out.println((n+1)/2);
        }
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new TaskC().run();
    }
}
